Attribute VB_Name = "modPPGtest"
Option Explicit
Private Declare Function vbaObjSetAddRef Lib "msvbvm60.dll" Alias "__vbaObjSetAddref" (ByRef objDest As Object, ByVal pObject As Long) As Long
'Public ppg As Object
Private ptrPPG As Long
Public Declare Function DefSubclassProc Lib "comctl32.dll" Alias "#413" (ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowSubclass Lib "comctl32.dll" Alias "#410" (ByVal hwnd As Long, ByVal pfnSubclass As Long, ByVal uIdSubclass As Long, Optional ByVal dwRefData As Long) As Long
Public Declare Function RemoveWindowSubclass Lib "comctl32.dll" Alias "#412" (ByVal hwnd As Long, ByVal pfnSubclass As Long, ByVal uIdSubclass As Long) As Long
'Public Declare Function ILCreateFromPathW Lib "shell32" (ByVal pwszPath As Long) As Long
Public Const NFR_UNICODE = 2
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Const NM_FIRST As Long = 0&
Public Const NM_CLICK As Long = NM_FIRST - 2& 'uses NMCLICK struct
Public Const NM_DBLCLK As Long = NM_FIRST - 3&
Public Const NM_RETURN As Long = NM_FIRST - 4&
Public Declare Function PathMatchSpecW Lib "shlwapi" (ByVal pszFileParam As Long, ByVal pszSpec As Long) As Long
Private Declare Function SysReAllocString Lib "oleaut32.dll" (ByVal pBSTR As Long, Optional ByVal pszStrPtr As Long) As Long
Private Declare Function StrCmpLogicalW Lib "shlwapi" (ByVal lpStr1 As Long, ByVal lpStr2 As Long) As Long
'Public gSpec As String
Private Const CBN_SELCHANGE = 1
Private Const CB_GETCURSEL = &H147
Private Enum SortType
    'NOTE: DUPLICATE...DELETE WHEN MERGED
    eSortName = &H2
    eSortSize = &H4
    eSortType = &H8
    eSortDateM = &H10
    eSortDateC = &H20
End Enum

Public Function Subclass2(hwnd As Long, lpfn As Long, Optional uId As Long = 0&, Optional dwRefData As Long = 0&) As Boolean
If uId = 0 Then uId = hwnd
    Subclass2 = SetWindowSubclass(hwnd, lpfn, uId, dwRefData):      Debug.Assert Subclass2
End Function

Public Function UnSubclass2(hwnd As Long, ByVal lpfn As Long, pid As Long) As Boolean
    UnSubclass2 = RemoveWindowSubclass(hwnd, lpfn, pid)
End Function

Private Function LPWSTRtoStr(lPtr As Long, Optional ByVal fFree As Boolean = True) As String
SysReAllocString VarPtr(LPWSTRtoStr), lPtr
If fFree Then
    Call CoTaskMemFree(lPtr)
End If
End Function

Public Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function
Public Function HiWord(ByVal DWord As Long) As Integer
HiWord = (DWord And &HFFFF0000) \ &H10000
End Function
Public Function LoWord(ByVal DWord As Long) As Integer
If DWord And &H8000& Then
    LoWord = DWord Or &HFFFF0000
Else
    LoWord = DWord And &HFFFF&
End If
End Function



'*************************************************
'The 2 functions that can't be used with AddressOf
'calls for subclassing/vtableswap on Form1
'
'CBDWndProc - Subclass hCombo (main comboboxex control handle)
'LVSWndProc - ListView subclass
Public Function LVSWndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal uIdSubclass As Long, ByVal dwRefData As Long) As Long
Dim ppg As Object
vbaObjSetAddRef ppg, dwRefData
Select Case uMsg
    Case WM_NOTIFYFORMAT
        'Enable Unicode support
        Debug.Print "Got NFMT on lvs main"
        LVSWndProc = NFR_UNICODE
        Exit Function
    Case WM_NOTIFY
        Dim tNMH As NMHDR
        CopyMemory tNMH, ByVal lParam, Len(tNMH)
        Select Case tNMH.Code
            Case WM_NOTIFYFORMAT
                Debug.Print "Got NFMT on DoLVNotify"
                LVSWndProc = NFR_UNICODE
            Case LVN_COLUMNCLICK
                Dim nmlv As NMLISTVIEW
                Dim nCol As Long
                ptrPPG = dwRefData 'store for later without blocking terminate again
                CopyMemory nmlv, ByVal lParam, Len(nmlv)
                nCol = GetHDItemlParam(SendMessage(tNMH.hWndFrom, LVM_GETHEADER, 0&, ByVal 0&), nmlv.iSubItem)
                Debug.Print "Column click " & nCol & ",si=" & nmlv.iSubItem
                ppg.LVColumnClick nCol
            Case NM_DBLCLK, NM_RETURN
                Debug.Print "Got dblclk/ret"
                ppg.LVDoubleClick ListView_GetSelectedItem(tNMH.hWndFrom)
        End Select
        If LVSWndProc Then Exit Function
    Case WM_DESTROY
        Call UnSubclass2(hwnd, PtrLVSWndProc(), uIdSubclass)
End Select

LVSWndProc = DefSubclassProc(hwnd, uMsg, wParam, lParam)
End Function
Private Function PtrLVSWndProc() As Long
PtrLVSWndProc = FARPROC(AddressOf LVSWndProc)
End Function
Public Function CBDWndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal uIdSubclass As Long, ByVal dwRefData As Long) As Long
'Handles messages for frmSearch.lvSearch
Dim ppg As Object
vbaObjSetAddRef ppg, dwRefData
  Select Case uMsg
    Case WM_NOTIFYFORMAT
        Debug.Print "Got NFMT on CBDWndProc"
        CBDWndProc = NFR_UNICODE
        Exit Function
    Case WM_COMMAND
        Dim lCode As Long
        lCode = HiWord(wParam)
        Select Case lCode
            Case CBN_SELCHANGE
                Debug.Print "CBD->SelChange"
                ppg.DirNavigate SendMessage(hwnd, CB_GETCURSEL, 0&, ByVal 0&)
        End Select


    Case WM_DESTROY
        Debug.Print "CDBWndProc->WM_DESTROY"
'        Call ppg.Cleanup
      Call UnSubclass2(hwnd, PtrCBDWndProc, uIdSubclass)
      
  End Select
  
  CBDWndProc = DefSubclassProc(hwnd, uMsg, wParam, lParam)
  
End Function
Private Function PtrCBDWndProc() As Long
PtrCBDWndProc = FARPROC(AddressOf CBDWndProc)
End Function

'**********************************************************
'
'ALSO, need to figure out what to do about sort callbacks
'
'Traded off some efficiency/speed for the convenience of
'only having a single callback function
Public Function ListViewSortProc(ByVal lParam1 As Long, _
                              ByVal lParam2 As Long, _
                              ByVal lParamSort As Long) As Long

Dim Val1 As String
Dim Val2 As String
Dim cr1 As Currency, cr2 As Currency
Dim dt1 As Date, dt2 As Date
Dim ires As Long

Dim ppg As Object
vbaObjSetAddRef ppg, ptrPPG

If (lParamSort And eSortName) = eSortName Then
    Val1 = ppg.LVItemName(lParam1)
    Val2 = ppg.LVItemName(lParam2)
    ires = StrCmpLogicalW(StrPtr(Val1), StrPtr(Val2))
    If (ires = -1) Then
        ires = 0
    ElseIf ires = 0 Then
        ires = 1
    Else
        ires = 2
    End If
ElseIf (lParamSort And eSortType) = eSortType Then
    Val1 = ppg.LVItemType(lParam1)
    Val2 = ppg.LVItemType(lParam2)
    ires = StrCmpLogicalW(StrPtr(Val1), StrPtr(Val2))
    If (ires = -1) Then
        ires = 0
    ElseIf ires = 0 Then
        ires = 1
    Else
        ires = 2
    End If
ElseIf (lParamSort And eSortSize) = eSortSize Then
    cr1 = ppg.LVItemSize(lParam1)
    cr2 = ppg.LVItemSize(lParam2)
    If cr1 < cr2 Then
        ires = 0
    ElseIf cr1 = cr2 Then
        ires = 1
    Else
        ires = 2
    End If
ElseIf (lParamSort And eSortDateM) = eSortDateM Then
    dt1 = ppg.LVItemDateM(lParam1)
    dt2 = ppg.LVItemDateM(lParam2)
    If dt1 < dt2 Then
        ires = 0
    ElseIf dt1 = dt2 Then
        ires = 1
    Else
        ires = 2
    End If
'ElseIf (lParamSort And eSortDateC) = eSortDateC Then
'    dt1 = ppg.LVItemDateM(lParam1)
'    dt2 = ppg.LVItemDateM(lParam2)
'    If dt1 < dt2 Then
'        ires = 0
'    ElseIf dt1 = dt2 Then
'        ires = 1
'    Else
'        ires = 2
'    End If
End If
If (lParamSort And SORT_ASCENDING) = 0 Then
    ListViewSortProc = ires
Else
    If ires = 0 Then
        ires = 2
    ElseIf ires = 2 Then
        ires = 0
    End If
    ListViewSortProc = ires
End If


End Function

